Bug 8252 - gcc 3.2 ICE on AltiVec code with optimisation turned on
Summary: gcc 3.2 ICE on AltiVec code with optimisation turned on
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: rtl-optimization (show other bugs)
Version: 3.2
: P3 normal
Target Milestone: ---
Assignee: Not yet assigned to anyone
URL:
Keywords: ice-on-valid-code
Depends on:
Blocks:
 
Reported: 2002-10-17 07:46 UTC by adam
Modified: 2003-07-25 17:33 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description adam 2002-10-17 07:46:01 UTC
I'm trying to compile an Apple AltiVec FFT program called "vBigDSP" with gcc 3.2. After changing brackets to braces on all vector initialisations, it compiles OK. But if I try any level of optimisation I get an internal compiler error. When I tried the latest snapshot (3.3-20021017) I got a different error without optimisation (I will report this separately).
--------------------------------------------------
hppb:/home/test/examples/applefft# gcc -v -save-temps -c vBigDSP.c -O
Reading specs from /usr/local/lib/gcc-lib/powerpc-unknown-linux-gnu/3.2/specs
Configured with: ../gcc-3.2/configure --enable-languages=c,c++ --enable-altivec
Thread model: posix
gcc version 3.2
 /usr/local/lib/gcc-lib/powerpc-unknown-linux-gnu/3.2/cpp0 -lang-c -v -D__GNUC__=3 -D__GNUC_MINOR__=2 -D__GNUC_PATCHLEVEL__=0 -D__GXX_ABI_VERSION=102 -DPPC -D__ELF__ -Dpowerpc -D__PPC__ -D__ELF__ -D__powerpc__ -D__PPC -D__powerpc -Acpu=powerpc -Amachine=powerpc -D__OPTIMIZE__ -D__STDC_HOSTED__=1 -D_CALL_SYSV -D_BIG_ENDIAN -D__BIG_ENDIAN__ -Amachine=bigendian -D_ARCH_PPC -D__unix__ -D__gnu_linux__ -D__linux__ -Dunix -D__unix -Dlinux -D__linux -Asystem=unix -Asystem=posix vBigDSP.c vBigDSP.i
GNU CPP version 3.2 (cpplib) (PowerPC GNU/Linux)
ignoring nonexistent directory "NONE/include"
ignoring nonexistent directory "/usr/local/powerpc-unknown-linux-gnu/include"
#include "..." search starts here:
#include <...> search starts here:
 /usr/local/include
 /usr/local/lib/gcc-lib/powerpc-unknown-linux-gnu/3.2/include
 /usr/include
End of search list.
 /usr/local/lib/gcc-lib/powerpc-unknown-linux-gnu/3.2/cc1 -fpreprocessed vBigDSP.i -quiet -dumpbase vBigDSP.c -O -version -o vBigDSP.s
GNU CPP version 3.2 (cpplib) (PowerPC GNU/Linux)
GNU C version 3.2 (powerpc-unknown-linux-gnu)
        compiled by GNU C version 3.3 20021017 (experimental).
vBigDSP.c: In function `fft_recursive':
vBigDSP.c:1623: Internal compiler error in print_operand, at config/rs6000/rs6000.c:6821
Please submit a full bug report,
with preprocessed source if appropriate.
See <URL:http://www.gnu.org/software/gcc/bugs.html> for instructions.
hppb:/home/test/examples/applefft#
--------------------------------------------------

Release:
3.2

Environment:
In-house port of Linux 2.4.19 (Debian based) on reasonably mature own design PowerPC G4 single board computer

How-To-Repeat:
vBigDSP_3.2.i.gz contains the intermediate output.
Comment 1 adam 2002-10-17 07:46:01 UTC
Fix:
fixed by:
http://gcc.gnu.org/ml/gcc-patches/2002-11/msg00185.html
Comment 2 Aldy Hernandez 2002-11-06 23:02:49 UTC
State-Changed-From-To: open->closed
State-Changed-Why: fixed